Bug 589948 - Fails to install dependencies for multiarch
Fails to install dependencies for multiarch
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: gtk2 (Show other bugs)
13
All Linux
low Severity medium
: ---
: ---
Assigned To: Matthias Clasen
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-05-07 07:14 EDT by Benjamin Otte
Modified: 2014-01-21 18:14 EST (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-06-27 12:09:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Benjamin Otte 2010-05-07 07:14:53 EDT
Description of problem:
yum fails at tracking the correct dependencies when installing packages in a multilib environment.

Version-Release number of selected component (if applicable):
yum-3.2.27-4.fc13

Steps to Reproduce:
1. Install x86_64 Fedora
2. Run yum install gtk2-devel
3. Run yum install gtk2-devel.i686

Actual results:
Installs all required lib packages, but fails to install required devel packages, when a devel package for a different arch is already available.

Expected results:
It installs all required packages, including required devel packages, (such as glib2-devel)

How reproducible:
always

Additional info:
I had this happen for some lib packages, too. For example installing freetype-devel.i686 did not install freetype.i686.
Comment 1 Michal Schmidt 2010-05-07 09:45:46 EDT
As far as yum is concerned, the dependency for gtk2-devel.i686 is fulfilled if glib2-devel.x86_64 is installed because the package only says:

Requires: glib2-devel >= %{glib2_version}

So yum is working here as expected.

The packager could use architecture-specific dependencies though:
http://www.rpm.org/wiki/PackagerDocs/ArchDependencies

I'm reassigning to gtk2 for consideration. But I suppose there's a LOT of packages with the same issue.
Comment 2 Matthias Clasen 2010-05-10 13:41:42 EDT
I'm not going to touch this until we get package guideline additions.
Comment 4 James Antill 2010-05-10 14:06:11 EDT
Just FMI ... Why not? What is the harm in adding the %{_isa} to the requires?

Do you think there's another solution?
Comment 5 Matthias Clasen 2010-05-10 18:36:15 EDT
Every single package in Fedora with explicit library dependencies has this issue. I'd rather not deal with it on a per-package basis and then revisit it when the packaging committee comes around to dealing with this.
Comment 6 Benjamin Otte 2010-05-11 04:22:31 EDT
I think it's a failure not of the packager but of the running system if it does not know that Requires: foo does not mean foo.same-arch or foo.noarch in at least 99.9% of the cases. So putting the blame on the packager is a bit counter-intuitive to me.

FWIW, when removing glibc.i686 yum uninstalled all my i686 packages, even though according to your logic at least the devel packages should have been happy to stay?
Comment 7 Michal Schmidt 2010-05-11 04:53:13 EDT
(In reply to comment #6)
> I think it's a failure not of the packager but of the running system if it does
> not know that Requires: foo does not mean foo.same-arch or foo.noarch in at
> least 99.9% of the cases. So putting the blame on the packager is a bit
> counter-intuitive to me.

What do you propose instead? Interpreting every "Requires: package" in a spec file as really meaning "Requires: package.%{_isa}" ? And then having a new special syntax for arch-independent Requires?

> FWIW, when removing glibc.i686 yum uninstalled all my i686 packages, even
> though according to your logic at least the devel packages should have been
> happy to stay?    

Both gtk2-devel.i686 and glib2-devel.i686 require "libc.so.6", which is provided only by glibc.i686. I see no inconsistency in my logic.
Comment 8 Benjamin Otte 2010-05-11 05:20:05 EDT
(In reply to comment #7)
> What do you propose instead? Interpreting every "Requires: package" in a spec
> file as really meaning "Requires: package.%{_isa}" ? And then having a new
> special syntax for arch-independent Requires?
> 
I'm not a guru packager yet, so I don't know of any side effects that might have, but from intuitoon I'd expect a "Requires: package" to mean "Requires: package.%{_isa}" or "Requires: package.noarch".
If a x86_64 package requires an i686 package explicitly, I'd expect that package to use "Requires: other-package.i686" explicitly.

> Both gtk2-devel.i686 and glib2-devel.i686 require "libc.so.6", which is
> provided only by glibc.i686. I see no inconsistency in my logic.    
>
Ah. I always thought devel packages don't require any so. That explains it.
Comment 9 Bug Zapper 2011-06-02 10:22:54 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 10 Bug Zapper 2011-06-27 12:09:51 EDT
Fedora 13 changed to end-of-life (EOL) status on 2011-06-25. Fedora 13 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.